module DLAbsSyn where

type Identifier = String

type Prg = Stm

data OpCode = OpAnd |  OpPlus |  OpMinus |  OpTimes |  OpEq |  OpLt 
 deriving (Show, Eq, Ord)

data Stm = CompoundStm Stm Stm
         | AssignStm   Identifier Exp 
         | IfStm       Exp Stm Stm 
         | WhileStm    Exp Stm 
         | PrintStm    [Exp]
 deriving (Show,Eq)

data Exp = IdExp   Identifier
         | NumExp  Int
         | OpExp   Exp OpCode Exp
         | EsepExp Stm Exp
 deriving (Show,Eq)

toOpCode :: Int -> OpCode
toOpCode 1 = OpAnd
toOpCode 2 = OpPlus
toOpCode 3 = OpMinus
toOpCode 4 = OpTimes
toOpCode 5 = OpEq
toOpCode 6 = OpLt


{-
data Stm = CompoundStm { stm1 :: Stm, stm2 :: Stm }
         | AssignStm   { id :: String, exp :: Exp }
         | PrintStm    { exps :: [Exp] }
 deriving (Show,Eq)

data Exp = IdExp   { id1 :: String }
         | NumExp  { num :: Int }
         | OpExp   { left :: Exp, op :: Int, right :: Exp }
         | EsepExp { stm :: Stm, exp1 :: Exp }
 deriving (Show,Eq)
-}

--data ExpList = PairExpList { head :: Exp, tail :: ExpList }
--             | LastExpList { head :: Exp }
